{******************************************}
{                                          }
{             FastReport V 4.x             }
{  FastReport frxIBOSet Script Support     }
{                                          }
{                                          }
{ Created by: Andreas Hesse                }
{ E-mail: delphi@ah3000.de                 }
{                                          }
{******************************************}

unit frxIBOSetRTTI;

interface

{$I frx.inc}

implementation

uses
  Windows, Classes, fs_iinterpreter, frxIBOSet, fs_iib_rtti
{$IFDEF Delphi6}
, Variants
{$ENDIF};


type
  TFunctions = class(TfsRTTIModule)
  private
    function CallMethod(Instance: TObject; ClassType: TClass; const MethodName: String; Caller: TfsMethodHelper): Variant;
    function GetProp(Instance: TObject; ClassType: TClass; const PropName: String): Variant;
    procedure SetProp(Instance: TObject; ClassType: TClass; const PropName: String; Value: Variant);
  public
    constructor Create(AScript: TfsScript); override;
  end;

{ TFunctions }

constructor TFunctions.Create(AScript: TfsScript);
begin
  inherited Create(AScript);
  with AScript do
  begin
    with AddClass(TfrxIBODataset, 'TfrxCustomDBDataset') do
    begin
      AddMethod('procedure Last', CallMethod);
      AddMethod('function FieldByName(Name: String): TIB_Column', CallMethod);
      //AddProperty('DataSet', 'TDataSet', GetProp, nil);
      AddProperty('Active', 'Boolean', GetProp, SetProp);
      //AddProperty('Fields', 'TFields', GetProp, nil);
    end;
  end;
end;

function TFunctions.CallMethod(Instance: TObject; ClassType: TClass; const MethodName: String; Caller: TfsMethodHelper): Variant;
begin
  Result := 0;
  if ClassType = TfrxIBODataset then
  begin
    if MethodName = 'LAST' then
      TfrxIBODataset(Instance).GetDataSet.Last
    else if MethodName = 'FIELDBYNAME' then
      Result := Integer(TfrxIBODataset(Instance).GetDataSet.FieldByName(Caller.Params[0]))
  end;
end;


function TFunctions.GetProp(Instance: TObject; ClassType: TClass; const PropName: String): Variant;
begin

end;

procedure TFunctions.SetProp(Instance: TObject; ClassType: TClass; const PropName: String; Value: Variant);
begin

end;

initialization
  fsRTTIModules.Add(TFunctions);

finalization
  if fsRTTIModules <> nil then
    fsRTTIModules.Remove(TFunctions);

end.
